Index: branches/htmlform/alloctypes.html
===================================================================
--- branches/htmlform/alloctypes.html	(revision 446)
+++ branches/htmlform/alloctypes.html	(revision 498)
@@ -1,17 +1,18 @@
-<html><head>
-
-<title>IP Database</title><meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
-
-<link rel="stylesheet" type="text/css" href="/ip/ipdb.css">
-<link rel="stylesheet" type="text/css" href="/ip/local.css">
-
+<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
+<html>
+<head>
+	<title>IP Database - Allocation Types</title>
+	<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
+	<link rel="stylesheet" type="text/css" href="/ip/ipdb.css">
+	<link rel="stylesheet" type="text/css" href="/ip/local.css">
 </head>
+
 <body>
 
 <table class="regular">
 
-<tr><td colspan=2 class="heading">Preseeded Allocation Types:</td><tr>
-
-<tr class="color1">
+<tr><td colspan=2 class="heading">Preseeded Allocation Types:</td></tr>
+
+<tr class="row0">
 <td>Customer netblock (default)</td>
 <td>A direct allocation /30 or larger to a customer.  Note that this does NOT 
@@ -20,30 +21,30 @@
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Static IP - Server pool</td>
 <td>A single IP from a pool designated for servers</td>
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Static IP - Cable</td>
 <td>A single IP address from a designated pool on the cable network.</td>
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Static IP - DSL</td>
 <td>A single IP address from a designated pool on the DSL network.</td>
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Static IP - Dialup</td>
 <td>A single IP address from a designated pool on a dialup RAS.</td>
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Static IP - Wireless</td>
 <td>A single IP address from a designated pool on a wireless connection.</td>
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Static pool - Servers</td>
 <td>A pool of IP addresses available for one-by-one assignment to servers in a 
@@ -51,5 +52,5 @@
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Static pool - Cable</td>
 <td>A pool of IP addresses available for one-by-one assignment to customers on 
@@ -57,5 +58,5 @@
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Static pool - DSL</td>
 <td>A pool of IP addresses available for one-by-one assignment to customers on 
@@ -64,5 +65,5 @@
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Static pool - Dialup</td>
 <td>A pool of IP addresses available for one-by-one assignment to dialup 
@@ -70,5 +71,5 @@
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Static pool - Wireless</td>
 <td>A pool of IP addresses available for one-by-one assignment to customers on a 
@@ -76,5 +77,5 @@
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>End-use netblock</td>
 <td>A /30 or larger allocation for arbitrary services - note this should not 
@@ -83,30 +84,30 @@
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Dialup netblock</td>
 <td>Netblock assigned to one or more RAS units in a POP</td>
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Dynamic DSL block</td>
 <td>Netblock for (mostly residential) PPPoE DSL.</td>
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Dynamic cable block</td>
 <td>Netblock for (mostly residential) DHCP cable.</td>
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Dynamic WiFi block</td>
 <td>Netblock for (mostly residential) (mostly) PPPoE wireless.</td>
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Dynamic VoIP block</td>
 <td>Netblock for DHCP-assigned VoIP services.</td>
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Static IP - LAN/POP</td>
 <td>A single IP address from a designated pool for internal LANs - either at a 
@@ -114,15 +115,15 @@
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Static IP - Managment</td>
 <td>A single IP address from a designated pool for managed devices.</td>
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Static IP - Wifi CPE</td>
 <td>A single IP address from a designated pool for wireless CPE devices.</td>
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Static pool - LAN/POP</td>
 <td>A pool of IP addresses available for one-by-one assignment to internal LAN 
@@ -130,20 +131,20 @@
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Static Pool - Managment</td>
 <td>A pool of IP addresses available for assignment to managed devices.</td>
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Static pool - Wifi CPE</td>
 <td>A pool of IP addresses available for assignment to wireless CPE devices.</td>
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Reserve for WAN blocks</td>
 <td>Reserve a chunk of IP space for core routers/etc.</td>
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Reserve for dynamic-route DSL netblocks</td>
 <td>Reserve a chunk of IP space for netblocks configured on the customer end via 
@@ -152,15 +153,15 @@
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Reserve for ATM</td>
 <td>Reserve a chunk of IP space for allocation to customers on ATM.</td>
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Reserve for fibre</td>
 <td>Reserve a chunk of IP space for customers on a fibre connection.</td>
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>WAN block</td>
 <td>Individual netblock assignment for a core router.  Always taken from a
@@ -168,5 +169,5 @@
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Dynamic-route DSL netblock</td>
 <td>Customer assignment for a netblock configured on the customer end via 
@@ -175,5 +176,5 @@
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>ATM block</td>
 <td>Customer assignment for a customer on ATM.  Always taken from a
@@ -181,5 +182,5 @@
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Fibre</td>
 <td>Customer assignment for a customer on fibre. Always taken from a block 
@@ -187,5 +188,5 @@
 </tr>
 
-<tr class="color2">
+<tr class="row1">
 <td>Routing</td>
 <td>Blocks not actually assigned to a service on their own, but which
@@ -193,5 +194,5 @@
 </tr>
 
-<tr class="color1">
+<tr class="row0">
 <td>Master block</td>
 <td>Allocations provided by the regional registry (ARIN, RIPE, LACNIC, AfriNIC, 